#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "rfc822_address.h"
#include "mrmacs.h"
#include "inline-funcs.h"

int main (int argc, char *argv[])
{
    char line[1024], *p;
    addrlist_t addr, na;
    route_t rt;
    int ix;
    printf ("*** Test for the address parser ***\n");
    for (;;) {
	printf ("Please enter an address:\n   "); fflush (stdout);
	if (fgets (line, 1024, stdin) == NULL) { break; }
	cuteol (line);
	p = line;
	addr = rfc822_addrlist (&p, "localhost");
	ifnull (addr) {
	    fprintf (stderr, "FATAL: %s\n", strerror (errno));
	    exit (1);
	}
	for (na = addr, ix = 1; noNULL(na); na = na->next, ++ix) {
	    printf ("%3d: ", ix);
	    if (na->error) {
		printf ("ERROR: %s\n", na->error); continue;
	    }
	    unlessnull (na->phrase) {
		printf ("%s ", na->phrase);
	    }
	    printf ("<");
	    unlessnull (na->route) {
		printf ("@%s", na->route->route);
		for (rt = na->route->next; noNULL(rt); rt = rt->next) {
		    printf (", @%s", rt->route);
		}
		printf (": ");
	    }
	    unlessnull (na->user) { printf ("%s@%s>", na->user, na->domain); }
	    unlessnull (na->comment) { printf (" (%s)", na->comment); }
	    printf ("\n");
	}
    }
    printf ("\n\n*** complete ***\n\n");
    return 0;
}
